'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactMotion = require('react-motion');

var _HeightReporter = require('./HeightReporter');

var _HeightReporter2 = _interopRequireDefault(_HeightReporter);

var Collapse = _react2['default'].createClass({
  displayName: 'Collapse',

  propTypes: {
    isOpened: _react2['default'].PropTypes.bool.isRequired,
    children: _react2['default'].PropTypes.node.isRequired,
    fixedHeight: _react2['default'].PropTypes.number,
    style: _react2['default'].PropTypes.object
  },

  getDefaultProps: function getDefaultProps() {
    return { fixedHeight: -1, style: {} };
  },

  getInitialState: function getInitialState() {
    return { height: 0, dirty: true };
  },

  componentWillMount: function componentWillMount() {
    this.height = '0.00';
  },

  componentWillReceiveProps: function componentWillReceiveProps(_ref) {
    var children = _ref.children;
    var fixedHeight = _ref.fixedHeight;

    if (fixedHeight < 0 && children !== this.props.children) {
      this.setState({ dirty: true });
    }
  },

  shouldComponentUpdate: _reactAddonsPureRenderMixin.shouldComponentUpdate,

  onHeightReady: function onHeightReady(height) {
    this.setState({ height: height, dirty: false });
  },

  renderHeightReporter: function renderHeightReporter() {
    if (!this.state.dirty && this.state.height) {
      return null;
    }
    var _props = this.props;
    var isOpened = _props.isOpened;
    var fixedHeight = _props.fixedHeight;

    var props = _objectWithoutProperties(_props, ['isOpened', 'fixedHeight']);

    return _react2['default'].createElement(_HeightReporter2['default'], _extends({ onHeightReady: this.onHeightReady }, props));
  },

  renderFixed: function renderFixed() {
    var _props2 = this.props;
    var isOpened = _props2.isOpened;
    var style = _props2.style;
    var children = _props2.children;
    var fixedHeight = _props2.fixedHeight;

    var props = _objectWithoutProperties(_props2, ['isOpened', 'style', 'children', 'fixedHeight']);

    return _react2['default'].createElement(
      _reactMotion.Motion,
      { defaultStyle: { height: 0 }, style: { height: (0, _reactMotion.spring)(isOpened ? fixedHeight : 0) } },
      function (_ref2) {
        var height = _ref2.height;
        return !isOpened && !height ? null : _react2['default'].createElement(
          'div',
          _extends({ style: _extends({}, style, { height: height, overflow: 'hidden' }) }, props),
          children
        );
      }
    );
  },

  render: function render() {
    var _this = this;

    var _props3 = this.props;
    var isOpened = _props3.isOpened;
    var style = _props3.style;
    var children = _props3.children;
    var fixedHeight = _props3.fixedHeight;

    var props = _objectWithoutProperties(_props3, ['isOpened', 'style', 'children', 'fixedHeight']);

    if (fixedHeight > -1) {
      return this.renderFixed();
    }

    var height = this.state.height;

    return _react2['default'].createElement(
      'div',
      null,
      this.renderHeightReporter(),
      _react2['default'].createElement(
        _reactMotion.Motion,
        { defaultStyle: { height: 0 }, style: { height: (0, _reactMotion.spring)(isOpened ? height : 0) } },
        function (st) {
          _this.height = parseFloat(st.height).toFixed(2);
          if (!isOpened && !st.height) {
            return null;
          }

          var newStyle = _this.height !== parseFloat(height).toFixed(2) ? {
            height: st.height,
            overflow: 'hidden'
          } : { height: 'auto' };

          return _react2['default'].createElement(
            'div',
            _extends({ style: _extends({}, style, newStyle) }, props),
            children
          );
        }
      )
    );
  }
});

exports['default'] = Collapse;
module.exports = exports['default'];
//# sourceMappingURL=Collapse.js.map