'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var HeightReporter = _react2['default'].createClass({
  displayName: 'HeightReporter',

  propTypes: {
    children: _react2['default'].PropTypes.node.isRequired,
    onHeightReady: _react2['default'].PropTypes.func.isRequired
  },

  componentDidMount: function componentDidMount() {
    this.height = this.refs.wrapper.clientHeight;
    if (this.height > 0) {
      return this.props.onHeightReady(this.height);
    }
  },

  shouldComponentUpdate: _reactAddonsPureRenderMixin.shouldComponentUpdate,

  componentDidUpdate: function componentDidUpdate() {
    if (this.refs.wrapper.clientHeight > 0 && this.refs.wrapper.clientHeight !== this.height) {
      this.height = this.refs.wrapper.clientHeight;
      return this.props.onHeightReady(this.height);
    }
  },

  render: function render() {
    var _props = this.props;
    var onHeightReady = _props.onHeightReady;
    var children = _props.children;

    var props = _objectWithoutProperties(_props, ['onHeightReady', 'children']);

    return _react2['default'].createElement(
      'div',
      { style: { height: 0, overflow: 'hidden' } },
      _react2['default'].createElement(
        'div',
        _extends({ ref: 'wrapper' }, props),
        children
      )
    );
  }
});

exports['default'] = HeightReporter;
module.exports = exports['default'];
//# sourceMappingURL=HeightReporter.js.map